case $CONFIG in
    '') . conf.sh ;;
esac
echo "Extracting Makefile (with variable substitutions)"
cat >Makefile <<!GROK!THIS!
#
# $Header: /h/guests/fmg/johnh/GEOFF_CVS/xcron/Makefile.SH,v 2.25 2000/04/13 05:08:04 johnh Exp $
#
# $Log: Makefile.SH,v $
# Revision 2.25  2000/04/13 05:08:04  johnh
# tomorrow added
#
# Revision 2.24  2000/04/13 04:57:44  johnh
# debugged lcron installation
#
# Revision 2.23  2000/04/13 04:31:53  johnh
# lcron release changes
#
# Revision 2.22  2000/02/08 08:56:42  geoff
#
# Integrate various changes from Geoff's branch into the now-master CVS
# repository.  As part of this integration, I cleaned up some, but not
# all, of the inconsistent coding style introduced by the LOC_CRON
# changes.  Important and substantive changes include:
#
#     Configure	Add errlist_in_stdio and getitimer/sigprocmask support.
#     Makefile.SH	Tiny cleanup to an expr command.
#     config.SH	Add errlist_in_stdio and getitimer/sigprocmask support.
#     errmsg.c	Add errlist_in_stdio support.
#     mainloop.c	Use setjmp/longjmp to ensure that we are blown off the
# 		select when we catch an alarm, even if we are running
# 		on a system that has reliable signals.  Also add
# 		reliable-signal support that properly resets the
# 		signal mask in the longjmp case.
#     parse.c	Fix a bug that could cause crontabs to be accepted
# 		with the wrong UID.  Be a bit more careful about
# 		parsing years.
#     runcmd.c	Add setjmp/longjmp and reliable-signal support.  (See
# 		mainloop.c).
#     xcron.c	Use setitimer to make absolutely sure that all alarms
# 		are disabled at startup.
#
# Revision 2.21  1998/07/30 20:42:20  geoff
# Many changes, accumulated over far too much time: allow batch to be
# suppressed; use exit 0/1 instead of true/false; work around problems
# with interactions between debuggers yacc/lex; don't assume . is in
# PATH.
#
# Revision 2.20  1995/11/27  01:59:14  geoff
# Make ln and strip configurable.  Support liby and libz.  Make building
# of the batch stuff optional.  Support installation of parallel
# versions under the "x" names.  Many changes in the first-time
# installation, including dropping /usr/lib/cron/master.
#
# Revision 2.19  1995/05/11  05:04:54  geoff
# Support a variable UID/GID for root.  Fix an undoubled dollar sign in
# the onetimestuff.  Use the default echo for all echoing.  Fix some
# dependencies to use doubled colons.
#
# Revision 2.18  87/04/01  23:49:48  geoff
# Use writability of CRONDIR to test for root, rather than /etc/passwd,
# which is often read-only.
# 
# Revision 2.17  87/03/31  22:31:53  geoff
# Add automatic crontab conversion code to 'onetimestuff'.  Improve the
# default .o dependencies so that make depend actually gets run, even
# though it means that make will produce harmless warning messages.
# Other minor cleanups.
# 
# Revision 2.16  87/01/10  19:12:20  geoff
# Many major changes to improve configurability.
# 
# Revision 2.15  86/12/01  14:44:57  geoff
# Improve the "all" and "clean" dependencies.
# 
# Revision 2.14  86/11/29  16:43:50  geoff
# Add support for the batch daemon as a member of "all".  Also improve
# configurability.
# 
# Revision 2.13  86/11/16  00:56:17  geoff
# Major changes to turn my makefile into a .SH file that will work
# with Larry Wall's configuration script.
# 
# Revision 2.12  86/04/17  21:53:53  geoff
# Add an install dependency, and improve the onetimestuff dependency.
# 
# Revision 2.11  86/04/13  13:24:53  geoff
# Add the directory library to at and cron
# 
# Revision 2.10  86/04/02  00:00:13  geoff
# Separate cron.h into cron.h and config.h.
# 
# Revision 2.9  86/04/01  22:03:20  geoff
# Add mainloop.c.
# 
# Revision 2.8  86/03/30  14:40:48  geoff
# Add tellcron;  add a file to at.
# 
# Revision 2.7  86/03/28  14:39:50  geoff
# Add the dump option to the debugging options.  Add nextrun and timesubs.
# Pipe lint output through fixlint.
# 
# Revision 2.6  86/03/25  19:57:05  geoff
# Add support for 'at'
# 
# Revision 2.5  86/01/04  16:15:20  geoff
# Begin preparations for integrating an 'at' command.  Add a
# 'make depend' dependency.
# 
# Revision 2.4  85/11/25  16:50:30  geoff
# Fix a bug in the definition of CTOBJ.
# 
# Revision 2.3  85/11/24  16:11:32  geoff
# Break out errmsg into a separate routine, and add dependencies for
# 'crontab'.
# 
# Revision 2.2  85/11/05  00:35:24  geoff
# Add collect.c.
# 
# Revision 2.1  85/11/02  19:06:43  geoff
# Begin changes for V.2 compatibility:  EDIT HERE section and onetimestuff
# dependency.  Also add a dependency for fifotest.
# 
# Revision 1.3  85/10/13  21:45:44  geoff
# Add fifotest, tags
# 
# Revision 1.2  85/10/12  01:33:26  geoff
# Break it up into separate modules
# 
# Revision 1.1  85/10/11  21:25:04  geoff
# Initial revision
# 
#
#	EDIT HERE
#

#
#	Where public executables go
#
BINDIR	=	$cronbin
#
#	Where cron control files go
#	Must match config.h
#
LIBDIR	=	$lib
#
#	Where cron itself goes
#
CRONDIR	=	$cronloc
#
# Where spooling directories go
#
SPOOLDIR =	$spool
#
#	Where 'at' job files go
#	Must match config.h
#
ATJOBDIR =	\$(SPOOLDIR)/atjobs
#
#	Where cron table files go
#	Must match config.h
#
CRONTABDIR =	\$(SPOOLDIR)/crontabs
#
#	Name of cron log file
#	Must match config.h
#
CRONLOG	=	log
#
#	Root's UID
#
ROOTUID	=	$rootuid
#
#	Root's GID
#
ROOTGID	=	$rootgid
#
#	Owner of cron directories
#
DAEMON	=	$daemon
#
#	Group for cron directories
#
DAEMONGID =	$daemongid
#
#	Where manual sources go
#
MANSRC	=	$mansrc
#
#	Extension for manual pages
#
MANEXT	=	$manext
#
#	Directories to create as part of 'onetimestuff'
#
BSPOOLDIR =	$bspoolexp
CRLIST	=	$crlib $crspool $crbspool

AWK	=	$awk
CC	=	$cc
CHGRP	=	$chgrp
CHMOD	=	$chmod
CHOWN	=	$chown
CP	=	$cp
CPP	=	$cpp
EGREP	=	$egrep
LN	=	$ln
MKDIR	=	$mkdir
RM	=	$rm
STRIP	=	$strip
TEST	=	$test
TOUCH	=	$touch
TR	=	$tr

#	Enable the following line for debugging.  Turn on only DUMP if
#	you want to install cron, but still would like to be able to
#	get dumps of the tables.
#
DEBUG	=	-DDEBUG -DYYDEBUG=1 -DDUMP
#DEBUG	=	-DDUMP
#DEBUG	=
CFLAGS	=	-O $iandd \$(DEBUG)
LDFLAGS	=	$iandd
LIBS	=	$ndirlib
LIBL	=	$libl
LIBY	=	$liby
LIBZ	=	$libz
#LDFLAGS	=
MEMSETC	=	$memsetc
MEMSETO	=	$memseto
NDIRC	=	$ndirc
NDIRO	=	$ndiro
MAKE	=	make
SHELL	=	/bin/sh
YFLAGS	=	-d
TZSETC	=	$tzsetc
TZSETO	=	$tzseto
#
#	END OF EDITING
#
BATCHFILES=	bcancel bqueue killbatch 

!GROK!THIS!
case "$buildbatch" in
y*)
    echo "SUPPRESSBATCH	=	(exit 1)" >> Makefile
    ;;
*)
    echo "SUPPRESSBATCH	=	(exit 0)" >> Makefile
    ;;
esac
case "$xcrononly" in
y*)
    echo "XCRONONLY	=	(exit 0)" >> Makefile
    ;;
*)
    echo "XCRONONLY	=	(exit 1)" >> Makefile
    ;;
esac
cat >>Makefile <<'!NO!SUBS!'

DIRS	=	$(LIBDIR) $(SPOOLDIR) $(CRONTABDIR) $(ATJOBDIR)

ATOBJ	=	at.o atlex.o atyacc.o deny.o errmsg.o fifo.o \
		$(NDIRO) sendcmd.o tempfile.o timesubs.o $(TZSETO)
ATCSRC	=	at.c atlex.c atyacc.c errmsg.c fifo.c \
		$(NDIRC) sendcmd.c tempfile.c timesubs.c $(TZSETC)
ATSRC	=	at.c atlex.l atyacc.y errmsg.c fifo.c \
		$(NDIRC) sendcmd.c tempfile.c timesubs.c $(TZSETC)
CRONOBJ	=	xcron.o collect.o debugio.o errmsg.o fifo.o limits.o \
		mainloop.o $(MEMSETO) msgproc.o $(NDIRO) nextrun.o parse.o \
		runcmd.o tempfile.o timesubs.o $(TZSETO)
CRONSRC	=	xcron.c collect.c debugio.c errmsg.c fifo.c limits.c \
		mainloop.c $(MEMSETC) msgproc.c $(NDIRC) nextrun.c parse.c \
		runcmd.c tempfile.c timesubs.c $(TZSETC)
CTOBJ	=	crontab.o deny.o errmsg.o fifo.o sendcmd.o tempfile.o
CTSRC	=	crontab.c deny.c errmsg.c fifo.c sendcmd.c tempfile.c
TELLOBJ	=	tellcron.o fifo.o errmsg.o sendcmd.o
TELLSRC	=	tellcron.c fifo.c errmsg.c sendcmd.c
HEADERS	=	config.h cron.h

all:	Makefile cron crontab at tellcron cronacct rclines sqdate batchstuff

cron:	$(CRONOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -o cron $(CRONOBJ) $(LIBZ) $(LIBS)

crontab:	$(CTOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -o crontab $(CTOBJ)

at:	$(ATOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -o at $(ATOBJ) $(LIBL) $(LIBY) $(LIBZ) \
	  $(LIBS)

tellcron:	$(TELLOBJ)
	$(CC) $(CFLAGS) $(LDFLAGS) -o tellcron $(TELLOBJ)

fifotest:	fifotest.o fifo.o
	$(CC) $(CFLAGS) -o fifotest fifotest.o fifo.o

batchstuff:
	$(SUPPRESSBATCH)  ||  (cd batch; $(MAKE))

y.tab.h atyacc.c:	atyacc.y
	yacc $(YFLAGS) atyacc.y
	sed -e 's/y\.tab\.c/atyacc.y/' -e '/^# *line /d' y.tab.c > atyacc.c
	$(RM) -f y.tab.c

#
#	Because GNU make assumes that RM is defined as "rm -f", we
#	must give an explicit dependency for atlex.c.  Who's the
#	genius that decided program names should include switches, or
#	that everyone who did an rm wanted it to succeed?  My RM is
#	going to remain "RM", dammit.  Grrr.
#
atlex.c:	atlex.l
	$(RM) -f atlex.c
	lex -t atlex.l | sed -e '/^# *line /d' > atlex.c

#
#	The make in the next dependency must NOT be $(MAKE), or a
#	make -n will generate an infinite recursion which will fill
#	up the process table and then hang trying to fork (how uncool).
#	This won't happen on non- "-n" makes, because the Makefile
#	will get changed and this dependency won't get re-executed.
#
Makefile: Makefile.SH conf.sh
	sh Makefile.SH
	make depend
	@echo You must re-run the rest of the make; exit 1

mdepend: mdepend.SH
	sh mdepend.SH

depend:	Makefile $(CRONSRC) $(CTSRC) $(ATCSRC) $(TELLSRC) $(HEADERS) y.tab.h
depend:	mdepend
depend: bdepend
	./mdepend

bdepend: batch/Makefile
	$(SUPPRESSBATCH)  ||  (cd batch; $(MAKE) depend)

#
#	The following target "ought to" have a make depend in it.  But
#	it only appears as a target of make depend itself, so it would
#	be redundant.
#
batch/Makefile: batch/Makefile.SH conf.sh
	$(SUPPRESSBATCH)  ||  (cd batch; sh Makefile.SH)

tags:	$(CRONSRC) $(CTSRC) $(ATSRC) $(TELLSRC) $(HEADERS) fifotest.c
	ctags -t -w $(CRONSRC) $(CTSRC) $(ATSRC) $(TELLSRC) \
	  $(HEADERS) fifotest.c
	$(SUPPRESSBATCH) \
	  ||  (cd batch; $(MAKE) tags; \
	    sed 's.	.	batch/.' batch/tags | sort -u - tags -o tags)

TAGS:	$(CRONSRC) $(CTSRC) $(ATSRC) $(TELLSRC) $(HEADERS) fifotest.c
	etags -t -w $(CRONSRC) $(CTSRC) $(ATSRC) $(TELLSRC) \
	  $(HEADERS) fifotest.c
	$(SUPPRESSBATCH)  ||  (cd batch; $(MAKE) TAGS)

lint:	$(CRONSRC) $(HEADERS) fifotest.c $(CTSRC) $(ATCSRC)
	lint $(DEBUG) $(CRONSRC) | fixlint
	lint $(DEBUG) $(CTSRC) | fixlint
	lint $(DEBUG) $(TELLSRC) | fixlint
	lint $(DEBUG) $(ATCSRC) | fixlint
	lint fifotest.c fifo.c | fixlint

clean:
	$(RM) -f Makefile.old *.o *.log core cron crontab at tellcron \
	  fifotest cronacct rclines sqdate atlex.c atyacc.c y.tab.h mdepend
#
#	Files produced by the Configure script.  Makefile and conf.sh are left.
#
	$(RM) -f .echotmp .greptmp Cppsym.c Cppsym a.out contains \
	  filexp foo1 foo2 grimble libc.list loc myread \
	  spitshell testcpp.c testcpp.out ticks ticks.c \
	  today try try.c try.o unix.list
	$(RM) -f bsd eunice usg v7
#
#	Files that may be produced by running cron with debugging on
#
	$(RM) -f crontime log
#
#	Batch daemon
#
	$(SUPPRESSBATCH)  ||  (cd batch; $(MAKE) clean)

realclean: clean
	$(RM) -f conf.sh Makefile tags TAGS
	$(SUPPRESSBATCH)  ||  (cd batch; $(MAKE) realclean)

install:	all
	$(CP) cron $(CRONDIR)/xcron
	$(STRIP) $(CRONDIR)/xcron
	$(CHMOD) 100 $(CRONDIR)/xcron
	$(CHGRP) $(ROOTGID) $(CRONDIR)/xcron
	$(CHOWN) $(ROOTUID) $(CRONDIR)/xcron
	$(XCRONONLY) \
	  ||  ($(RM) -f $(CRONDIR)/cron; \
	    $(LN) $(CRONDIR)/xcron $(CRONDIR)/cron)
	$(SUPPRESSBATCH) \
	  ||  ($(CP) batch/batchd $(CRONDIR); \
	    $(STRIP) $(CRONDIR)/batchd; \
	    $(CHMOD) 100 $(CRONDIR)/batchd; \
	    $(CHGRP) $(ROOTGID) $(CRONDIR)/batchd; \
	    $(CHOWN) $(ROOTUID) $(CRONDIR)/batchd)
	$(CP) at $(BINDIR)/xat
	$(CP) crontab $(BINDIR)/xcrontab
	$(CP) tellcron $(BINDIR)/tellxcron
	cd $(BINDIR); \
	  $(STRIP) xat xcrontab tellxcron; \
	  $(CHGRP) $(ROOTGID) xat xcrontab tellxcron; \
	  $(CHOWN) $(ROOTUID) xat xcrontab tellxcron; \
	  $(CHMOD) 4111 xat xcrontab; \
	  $(CHMOD) 100 tellxcron
	@set -x; $(XCRONONLY) \
	  ||  (cd $(BINDIR); $(RM) -f at crontab tellcron; \
	    $(LN) xat at; $(LN) xcrontab crontab; $(LN) tellxcron tellcron)
	@set -x; for manpage in at.1 cron.1m crontab.1 tellcron.1m; \
	do \
	    man=`expr "$$manpage" : '\(.*\)\.[0-9]m*$$'`; \
	    xman=x$$man; \
	    case "$$man" in tellcron) xman=tellxcron;; esac; \
	    ext=`expr "$$manpage" : '.*\.\([0-9]m*\)$$'`; \
	    bext=$$ext; \
	    mext=$${ext}$(MANEXT); \
	    case "$$ext" in 1m) mext=1m; bext=1;; esac; \
	    $(RM) -f $(MANSRC)/man$$ext/$$xman.*; \
	    $(CP) $$man.$$ext $(MANSRC)/man$$bext/$$xman.$$mext; \
	    $(CHMOD) 644 $(MANSRC)/man$$bext/$$xman.$$mext; \
	    $(XCRONONLY) \
	      || ($(RM) -f $(MANSRC)/man$$bext/$$man.*; \
		$(LN) $(MANSRC)/man$$bext/$$xman.$$mext \
		  $(MANSRC)/man$$bext/$$man.$$mext); \
	done
	$(SUPPRESSBATCH)  ||  (cd batch; $(CP) batch $(BATCHFILES) $(BINDIR))
	$(SUPPRESSBATCH) \
	  ||  (cd $(BINDIR); \
	    $(STRIP) batch; \
	    $(CHGRP) $(ROOTGID) batch $(BATCHFILES); \
	    $(CHOWN) $(ROOTUID) batch $(BATCHFILES); \
	    $(CHMOD) 4111 batch; chmod 755 $(BATCHFILES))
	$(SUPPRESSBATCH) \
	  ||  ($(CP) batch/cleanup $(BSPOOLDIR)/.cleanup; \
	    $(CHMOD) 744 $(BSPOOLDIR)/.cleanup; \
	    $(CHGRP) $(DAEMONGID) $(BSPOOLDIR)/.cleanup; \
	    $(CHOWN) $(DAEMON) $(BSPOOLDIR)/.cleanup)

install.lcron:
	sed -e "s@/usr/local/lib/xcron/lib@$(LIBDIR)@" -e "s@/usr/local/lib/xcron/bin@$(BINDIR)@" < lcron_support/location_monitor.pl >$(CRONDIR)/location_monitor
	$(CHMOD) 0755 $(CRONDIR)/location_monitor
	$(CP) lcron_support/printcap_set_default $(CRONDIR)
	$(CP) lcron_support/run_every $(BINDIR)
	$(CP) lcron_support/tomorrow $(BINDIR)
	$(MKDIR) $(LIBDIR)/events
	$(CHMOD) 0755 $(LIBDIR)/events
	$(TOUCH) $(LIBDIR)/netstat_mapping
	$(CHMOD) 0644 $(LIBDIR)/netstat_mapping

install.lcron.redhat:
	echo "This part of lcron installation is RedHat specific."
	$(CP) lcron_support/xcron /etc/rc.d/init.d
	chkconfig --add xcron
	@test -f /etc/apmd_proxy && mv /etc/apmd_proxy /etc/apmd_proxy-
	sed -e "s@/usr/local/lib/xcron/lib@$(LIBDIR)@" -e "s@/usr/local/lib/xcron/bin@$(BINDIR)@" < lcron_support/power_monitor.pl >/etc/apmd_proxy
	$(CHMOD) 0755 /etc/apmd_proxy


#
#	The following target does one-time setup for a cron installation.
#	You should never have to re-run it.
#
onetimestuff:	all
	@echo "Note:  make onetimestuff must be run by root"
#	
#	Make sure all the necessary directories are created.
#	
	@for dir in blurfl/dyick $(CRLIST); do \
	    case $$dir in \
	    blurfl/dyick) ;; \
	    *)	if $(TEST) ! -d $$dir; then \
		    path=''; \
		    for part in `echo $$dir | $(TR) / ' '`; do \
			path=$$path/$$part; \
			if $(TEST) ! -d $$path; then \
			    echo $(MKDIR) $$path; $(MKDIR) $$path; \
			    $(CHMOD) 755 $$path; \
			    if $(TEST) $$path = $(BSPOOLDIR); then \
				$(CHGRP) $(ROOTGID) $$path; \
				$(CHOWN) $(ROOTUID) $$path; \
			    else \
				$(CHGRP) $(DAEMONGID) $$path; \
				$(CHOWN) $(DAEMON) $$path; \
			    fi; \
			fi; \
		    done; \
		fi; \
	    esac; \
	done
#	
#	Set up directory modes and convert existing crontabs
#	
	chmod 700 $(CRONTABDIR) $(ATJOBDIR)
	case "$(CRONTABDIR)" in \
	    /var/spool/cron/crontabs|/usr/spool/cron/crontabs) \
		;; \
	    *) \
		if $(TEST) ! -r $(CRONTABDIR)/root; then \
		    cp /usr/spool/cron/crontabs/* $(CRONTABDIR); \
		    cd $(CRONTABDIR); \
		    for i in *; do \
			chown $$i $$i; \
		    done; \
		fi; \
		;; \
	esac
	for i in $(CRONTABDIR)/*; do \
	    case "$$i" in \
		"$(CRONTABDIR)/*") ;; \
		*) if $(EGREP) '^[ 	]*[0-9*]' $$i >/dev/null 2>&1; then \
		    if $(TEST) $$i = $(CRONTABDIR)/root; then \
			egrep -v atrun $$i; \
		    else \
			cat $$i; \
		    fi \
		      | $(AWK) -f croncvt.awk > /tmp/cvt$$$$; \
		    if $(TEST) $$i = $(CRONTABDIR)/root; then \
			$(SUPPRESSBATCH) \
			  ||  echo - Sun 06:00 $(BSPOOLDIR)/.cleanup \
			    >> /tmp/cvt$$$$; \
			echo - Sun 06:05 cd $(LIBDIR)\; $(CP) log olog\; \
			  $(CP) /dev/null log >> /tmp/cvt$$$$; \
		    fi; \
		    $(CP) /tmp/cvt$$$$ $$i; \
		    $(RM) -f /tmp/cvt$$$$; \
		   fi ;; \
	    esac; \
	done
	if $(TEST) ! -r $(LIBDIR)/userlimits ; then \
	    $(CP) userlimits $(LIBDIR); \
	    $(CHMOD) 644 $(LIBDIR)/userlimits; \
	    $(CHGRP) $(DAEMONGID) $(LIBDIR)/userlimits; \
	    $(CHOWN) $(DAEMON) $(LIBDIR)/userlimits; \
	fi
	$(TOUCH) $(LIBDIR)/$(CRONLOG)
	$(CHMOD) 600 $(LIBDIR)/$(CRONLOG)
	$(CHGRP) $(DAEMONGID) $(LIBDIR)/$(CRONLOG)
	$(CHOWN) $(DAEMON) $(LIBDIR)/$(CRONLOG)

# AUTOMATICALLY GENERATED MAKE DEPENDENCIES--PUT NOTHING BELOW THIS LINE
# DO NOT DELETE THIS LINE - make depend uses it
$(ATOBJ)::	conf.sh
	make depend
	@ echo "You must re-run the rest of the make"; exit 1

$(CRONOBJ)::	conf.sh
	make depend
	@ echo "You must re-run the rest of the make"; exit 1

$(CTOBJ)::	conf.sh
	make depend
	@ echo "You must re-run the rest of the make"; exit 1

$(TELLOBJ)::	conf.sh
	make depend
	@ echo "You must re-run the rest of the make"; exit 1
!NO!SUBS!
$eunicefix Makefile
