case $CONFIG in
    '') . ../conf.sh ;;
esac
echo "Extracting config.h (with variable substitutions)"
cat >config.h <<!GROK!THIS!
#ifdef GEN_ID
#ifndef lint
static char Config_Id[] =
	"$Header: /h/guests/fmg/johnh/GEOFF_CVS/xcron/batch/config.SH,v 1.5 1995/11/27 05:04:05 geoff Exp $";
#endif
#endif

/*
 * $Log: config.SH,v $
 * Revision 1.5  1995/11/27 05:04:05  geoff
 * Cosmetic RCS header changes.  Support SIG_TYPE, HASNLIST_UNION, and
 * HASLOADAVG.
 *
 * Revision 1.4  87/03/31  23:14:50  geoff
 * Add information to describe sysinfo-based load averages.
 * 
 * Revision 1.3  87/01/10  23:29:01  geoff
 * Get SPOOLDIR from bspoolexp, not bspool.  Handle various versions of
 * bzero.
 * 
 * Revision 1.2  86/11/29  16:00:11  geoff
 * Major changes to convert config.h into config.SH, to make it configurable.
 * 
 * Revision 1.1  86/06/26  23:31:30  geoff
 * Initial revision
 * 
 */

/*
 * How many register declarations are paid attention to
 */
#define reg1	$reg1
#define reg2	$reg2
#define reg3	$reg3
#define reg4	$reg4
#define reg5	$reg5
#define reg6	$reg6
#define reg7	$reg7
#define reg8	$reg8
#define reg9	$reg9
#define reg10	$reg10
#define reg11	$reg11
#define reg12	$reg12
#define reg13	$reg13
#define reg14	$reg14
#define reg15	$reg15
#define reg16	$reg16

/*
 * Where to put spooled batch files.
 */
#define	SPOOLDIR	"$bspoolexp"

/*
 * Where the pid of the batch daemon is found.
 */
#define PIDFILE		"$batchpid"

/*
 * USG/PWB systems use strchr/strchr, to avoid conflicting with common
 * variable names.  V7/BSD systems do not.  Enable the following two
 * definitions on V7/BSD systems.
 */

#$strchr strchr		index			/* For V7 and BSD systems */
#$strchr strrchr	rindex			/* For V7 and BSD systems */

/*
 * USG systems call the child-death signal SIGCLD;  BSD calls it SIGCHLD
 */
#$sigchld SIGCHLD	SIGCLD			/* Death-of-child signal */

/*
 * Signal-handling type definition.
 */
#define SIG_TYPE $sigtype			/* Type of signal handlers */

/*
 * Description of how the kernel keeps a load average.  If you have a
 * USG system, you may enjoy tinkering with these.
 */
#$loadavg HASLOADAVG				/* System keeps a load avg */
#$hassysinfo HASSYSINFO				/* System has sysinfo.h */
#define AVENRUN		"$nrunvar"		/* Where load avg is kept */
#define MINLOADTIME	15			/* How often to chk load avg */
#define NRUNTYPE	$nruntype		/* Type type of AVENRUN */
#define NRUNFACTOR	($nrunfactor)		/* Division factor */
#define TICKS		$ticks			/* System clock ticks per sec */
#define TC0		60			/* Short-term time cnst, secs */
#define TC1		(5*60)			/* Medium-term time const */
#define TC2		(15*60)			/* Long-term time const */

/*
 * Minor system variations.
 */
#$dup2 HASDUP2					/* System has dup2() */
#$fcntl HASFCNTL				/* System has fcntl.h */
#$getwd HASGETWD				/* System has getwd () */
#$pgetstypes PARAMGETSTYPES			/* param.h includes types.h */
#$fchmod HASFCHMOD				/* System has fchmod() */
#$fchown HASFCHOWN				/* System has fchown() */
#$rename HASRENAME				/* System has rename() */
#$unique HASUNIQUE				/* System has unique() */
#$nlisth HASNLIST_H				/* System has nlist.h */
#$nlistunion HASNLIST_UNION			/* nlist.h has union in it */
#$resourceh HASRLIMIT				/* System has resource limits */
#$setpgrp HASSETPGRP				/* System has setpgrp () */
#$setpargs SETPGRPARGS				/* Setpgrp() takes arguments */
#$initgroups INITGROUPS				/* System has initgroups() */
#$relsig RELIABLE_SIGNALS			/* System has reliable sigs */

/*
 * If your system has vfork, disable the following definition.
 */
#$novfork vfork		fork			/* For V7 and USG systems */

/*
 * How to make use of the directory libraries
 */
#$libndir LIBNDIR				/* System has ndir.h */
#$usendir USENDIR				/* We must provide ndir.c */

/*
 * Define this if your system supports the #! magic number on execs
 */
#$hassharpbang SHARPBANG			/* System supports "#!" */
#define SBSTRING "$sharpbang"			/* String used for "#!" */

/*
 * If your system has ulimit() but not getrlimit(), enable the
 * following definition.
 */
#$ulimit ULIMIT

/*
 * Type of nice levels used on your systems.  Define RELNICE if nice(2)
 * takes a relative number.  Undefine it if nice(2) takes an absolute
 * number.
 *
 * If RELNICE is defined, MINNICE/MAXNICE define the resultant nice range
 * imposed by the system.  If RELNICE is undefined, MINNICE/MAXNICE define
 * the range of values nice(2) will accept;  typically MINNICE is negative
 * in this case.
 */
#$relnice RELNICE		/* Nice(2) takes a relative number */
#define MINNICE	$minnice	/* Minimum nice value */
#define MAXNICE	$maxnice	/* Maximum nice value */

/*
 * Mailer to use
 */
#ifdef BSD
#define MAILER		"/usr/lib/sendmail"
#define MAILERNAME	"sendmail"
#else
#define MAILER		"/bin/mail"
#define MAILERNAME	"mail"
#endif

/*
 * Who to mail to in case of trouble
 */
#define SUPERVISOR	"batch"

/*
 * Name of a queue profile file
 */
#define PROFILE		"profile"

/*
 * Where to find the unix namelist
 */
#ifdef BSD
#define NAMELIST	"/vmunix"
#else
#define NAMELIST	"/unix"
#endif

/*
 * Limits on things
 */
#define	NQUEUES		16	/* Max # of queues */
#define	MAXENTRIES	50	/* Max # per queue */
#define MAXTOTAL	50	/* Max # of total jobs */

/*
 * Where to put the debugging output file.  Don't put it in /usr/spool/batch,
 * or the system will think it's a batch queue.
 */
#ifdef DEBUG
#define DEBUGFILE	"/usr/spool/batch/troff/DEBUG"
#endif

/*
 * Where to keep a unique value
 */
#define UNIQUEFILE	".uniqueval"
#define ULOCKFILE	".ulock"

/*
 * Default loadsched/loadstop values.  There is something to be said for
 * setting these ridiculously high.  There is also something to be said for
 * setting them to "reasonable" defaults.  Take your pick.
 *
 * For proper hysteresis, DEFHALT should exceed DEFSCHED, and DEFSTOP should
 * exceed DEFSTART.  If you violate this constraint, the DEFSCHED/DEFSTART
 * values will be effectively ignored, and you will operate without hysteresis.
 */
#define DEFHALT		30.0	/* Default loadhalt value for a queue */	
#define DEFSCHED	25.0	/* Default loadsched value for a queue */
#define DEFSTOP		50.0	/* Default loadstop value for a queue */
#define DEFSTART	40.0	/* Default loadstart value for a queue */

/*
 * Default averages to use for scheduling and stopping.  0 is the short-term
 * average, 1 is the medium-term, and 2 is the long-term.
 *
 * For proper hysteresis, HALT (STOP) should be less than SCHED (START).
 * If this constraint is violated, you may get strange and
 * complex behavior.  In any case, the code is actually written so that
 * if both the HALT (STOP) and SCHED (START) conditions are satisfied,
 * the HALT (STOP) condition will take precedence.
 *
 * The HALT/STOP averages used are different on non-BSD systems because we
 * need more responsiveness in the absence of so-called "job control".  (It
 * really doesn't matter much, though, since the profile file can override
 * these).
 */
#ifdef HASLOADAVG
#define DEFHALTAVERAGE	1	/* Halt scheduling based on medium-term avg */
#define DEFSCHEDAVERAGE	2	/* Restart scheduling based on long term */
#define DEFSTOPAVERAGE	0	/* Do stopping based on short-term average */
#define DEFSTARTAVERAGE	1	/* Restart based on medium-term average */
#else
#define DEFHALTAVERAGE	0	/* Halt scheduling based on short-term avg */
#define DEFSCHEDAVERAGE	1	/* Restart scheduling based on medium term */
#endif

/*
 * Scheduling interval.  Every NSEC seconds, all directories are scanned
 * for new jobs, which is fairly expensive.  On the other hand, increasing
 * NSEC degrades the responsiveness of the batch system.
 */
#ifdef DEBUG
#define NSEC		30	/* Directory scanning interval, seconds */
#else
#define NSEC		(5*60)	/* Directory scanning interval, seconds */
#endif
!GROK!THIS!
