#ifndef lint
static char Rcs_Id[] =
	"$Header: /h/guests/fmg/johnh/GEOFF_CVS/xcron/errmsg.c,v 2.4 2000/02/08 08:56:42 geoff Exp $";
#endif

/*
 * $Log: errmsg.c,v $
 * Revision 2.4  2000/02/08 08:56:42  geoff
 *
 * Integrate various changes from Geoff's branch into the now-master CVS
 * repository.  As part of this integration, I cleaned up some, but not
 * all, of the inconsistent coding style introduced by the LOC_CRON
 * changes.  Important and substantive changes include:
 *
 *     Configure	Add errlist_in_stdio and getitimer/sigprocmask support.
 *     Makefile.SH	Tiny cleanup to an expr command.
 *     config.SH	Add errlist_in_stdio and getitimer/sigprocmask support.
 *     errmsg.c	Add errlist_in_stdio support.
 *     mainloop.c	Use setjmp/longjmp to ensure that we are blown off the
 * 		select when we catch an alarm, even if we are running
 * 		on a system that has reliable signals.  Also add
 * 		reliable-signal support that properly resets the
 * 		signal mask in the longjmp case.
 *     parse.c	Fix a bug that could cause crontabs to be accepted
 * 		with the wrong UID.  Be a bit more careful about
 * 		parsing years.
 *     runcmd.c	Add setjmp/longjmp and reliable-signal support.  (See
 * 		mainloop.c).
 *     xcron.c	Use setitimer to make absolutely sure that all alarms
 * 		are disabled at startup.
 *
 * Revision 2.3  1999/07/14 05:22:30  johnh
 * location awareness (all in LOC_CRON) and a few cleanups/bugfixes
 *
 * Revision 2.2  1995/05/11 05:05:23  geoff
 * Minor RCS header changes.
 *
 * Revision 2.1  85/11/23  12:16:36  geoff
 * Initial revision
 * 
 */

/*
 * Subroutine to translate a system error number into an ASCII string.
 */

#include "config.h"
#include <errno.h>
#include <stdio.h>

char *		errmsg ();		/* Return an error message string */

extern int	errno;			/* System error number */
#ifndef ERRLIST_IN_STDIO
extern char *	sys_errlist[];		/* System error messages */
extern int	sys_nerr;		/* Size of sys_errlist */
#endif /* ERRLIST_IN_STDIO */

/*
 *  Return system error string.
 *  Argument:
 *      if error is positive, assume that it is an error number.
 *      if error is 0, then use the message associated with the
 *      current value in errno.
 */
char * errmsg (error)				/* Return error message */
    int			error;			/* Error number */
    {
    static char		buf[40];		/* Space for generic message */

    if (error == 0)
	error = errno;
    if (error <= 0 || error > sys_nerr)
	{
	(void) sprintf (buf, "unknown error %d", error);
	return buf;
	}
    else
	return sys_errlist[error];
}
