#!/usr/bin/perl -w

#
# power_monitor.pl
# $Id: power_monitor.pl,v 1.1 2000/04/13 04:31:54 johnh Exp $
#
# Copyright (C) 1999 by John Heidemann
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License,
# version 2, as published by the Free Software Foundation.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License along
# with this program; if not, write to the Free Software Foundation, Inc.,
# 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
#



sub usage {
    print STDERR <<END;
usage: $0 [-D]

map linux apmd-3.0beta9 events into lcron events
monitor and filter location, sending signals to lcron if it changes
See apmd(8) for details.

To install this, copy it to /etc/apmd/apmd_proxy (or just
/etc/apmd_proxy on RedHat 6.1).

END
    exit 1;
}

use strict;

use Getopt::Long;
&usage if ($#ARGV >= 0 && $ARGV[0] eq '-?');
my(%opts);
&GetOptions(\%opts, qw(d));
&usage if ($#ARGV < 0);

my($BINDIR) = '/usr/local/lib/xcron/bin';
my($LIBDIR) = '/usr/local/lib/xcron/lib';

my(%pass_commands) = qw(start pass
			stop pass
			suspend pass
			standby drop
			resume pass
			change check);

my($command) = $ARGV[0];
if (defined($pass_commands{$command}) && $pass_commands{$command} ne 'drop') {
    if ($command eq 'change' && $ARGV[1] eq 'power') {
	open(APM, "</proc/apm") || die "$0: cannot open /proc/apm\n";
	my($apm) = <APM>;
	my(@apm) = split(/ /, $apm);
	$command = ($apm[3] =~ /1/) ? "ac" : "battery";
	close APM;
    };
    my($fn) = "$LIBDIR/events/power";
    open(POWER, ">$fn") || die "$0: cannot open $fn\n";
    print POWER "power:$command\n";
    close POWER;
    chmod 0644, $fn || die "$0: cannot chmod $fn\n";
    &tellxcron;
};
exit 0;

sub tellxcron {
    system("$BINDIR/tellxcron", "-L");
}
