#ifndef lint
static char Rcs_Id[] =
	"$Header: /h/guests/fmg/johnh/GEOFF_CVS/xcron/msgproc.c,v 2.4 1995/05/11 05:05:38 geoff Exp $";
#endif

/*
 * $Log: msgproc.c,v $
 * Revision 2.4  1995/05/11 05:05:38  geoff
 * Minor RCS header changes.
 *
 * Revision 2.3  86/11/29  19:52:25  geoff
 * Change all the register declarations to be portable across
 * machines with varying numbers of registers.
 * 
 * Revision 2.2  85/11/24  16:13:18  geoff
 * Fix some lint complaints.  Take out errmsg;  it's now in its own file.
 * 
 * Revision 2.1  85/11/05  00:57:59  geoff
 * Force to release 2
 * 
 * Revision 1.2  85/11/05  00:36:11  geoff
 * Put syntax error messages out to the error file instead of stderr.
 * 
 * Revision 1.1  85/10/12  01:33:34  geoff
 * Break it up into separate modules
 * 
 */

/*
 * Message formatting routines for the cron daemon
 */

#include "cron.h"
#include <ctype.h>
#include <stdio.h>
#include <time.h>

char *		timenonl ();		/* Return a time w/o newline */
void		synerr ();		/* Issue syntax error message */
char *		printable ();		/* Return printable version of char */

extern char *	curfile;		/* Current file's name */
extern int	curline;		/* Line number in current file */
extern FILE *	errfile;		/* File to report errors on */
extern int	errfull;		/* NZ if error file has messages */

char * timenonl (then)			/* Return ASCII time w/o newline */
    time_t		then;		/* Time to be converted */
    {
    char *		buf;		/* Return value from ctime */

    buf = ctime (&then);
    buf[24] = '\0';			/* Trim off newline */
    return buf;
    }

void synerr (msg)				/* Issue syntax message */
    char *		msg;			/* Message to issue */
    {
    (void) fprintf (errfile, "%s line %d:  %s\n", curfile, curline, msg);
    errfull = 1;
    }

/*
 * Return printable representation of a character
 */
char * printable (ch)				/* Printable version of char */
    reg1 int		ch;			/* Character to evaluate */
    {
    static char		buf[5];			/* Place for return value */

    buf[0] = ch;
    buf[1] = '\0';
    if ((isprint (ch)  ||  ch == '\t')  &&  !iscntrl (ch))
	return buf;
    if (ch == '\n')
	return "\\n";
    else if (ch == '\b')
	return "\\b";
    (void) sprintf (buf, "\\%o", ch);
    return buf;
    }
